Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -3309,59 +4005,59 @@
 void molecule::CreateListOfBondsPerAtom(ofstream *out)
 {
-	bond *Binder = NULL;
-	atom *Walker = NULL;
-	int TotalDegree;
-	*out << Verbose(1) << "Begin of Creating ListOfBondsPerAtom: AtomCount = " << AtomCount << "\tBondCount = " << BondCount << "\tNoNonBonds = " << NoNonBonds << "." << endl;
-
-	// re-allocate memory
-	*out << Verbose(2) << "(Re-)Allocating memory." << endl;
-	if (ListOfBondsPerAtom != NULL) {
-		for(int i=AtomCount;i--;)
-			Free((void **)&ListOfBondsPerAtom[i], "molecule::CreateListOfBondsPerAtom: ListOfBondsPerAtom[i]");
-		Free((void **)&ListOfBondsPerAtom, "molecule::CreateListOfBondsPerAtom: ListOfBondsPerAtom");
-	}
-	if (NumberOfBondsPerAtom != NULL)
-		Free((void **)&NumberOfBondsPerAtom, "molecule::CreateListOfBondsPerAtom: NumberOfBondsPerAtom");
-	ListOfBondsPerAtom = (bond ***) Malloc(sizeof(bond **)*AtomCount, "molecule::CreateListOfBondsPerAtom: ***ListOfBondsPerAtom");
-	NumberOfBondsPerAtom = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CreateListOfBondsPerAtom: *NumberOfBondsPerAtom");
-
-	// reset bond counts per atom
-	for(int i=AtomCount;i--;)
-		NumberOfBondsPerAtom[i] = 0;
-	// count bonds per atom
-	Binder = first;
-	while (Binder->next != last) {
-		Binder = Binder->next;
-		NumberOfBondsPerAtom[Binder->leftatom->nr]++;
-		NumberOfBondsPerAtom[Binder->rightatom->nr]++;
-	}
-	for(int i=AtomCount;i--;) {
-		// allocate list of bonds per atom
-		ListOfBondsPerAtom[i] = (bond **) Malloc(sizeof(bond *)*NumberOfBondsPerAtom[i], "molecule::CreateListOfBondsPerAtom: **ListOfBondsPerAtom[]");
-		// clear the list again, now each NumberOfBondsPerAtom marks current free field
-		NumberOfBondsPerAtom[i] = 0;
-	}
-	// fill the list
-	Binder = first;
-	while (Binder->next != last) {
-		Binder = Binder->next;
-		ListOfBondsPerAtom[Binder->leftatom->nr][NumberOfBondsPerAtom[Binder->leftatom->nr]++] = Binder;
-		ListOfBondsPerAtom[Binder->rightatom->nr][NumberOfBondsPerAtom[Binder->rightatom->nr]++] = Binder;
-	}
-
-	// output list for debugging
-	*out << Verbose(3) << "ListOfBondsPerAtom for each atom:" << endl;
-	Walker = start;
-	while (Walker->next != end) {
-		Walker = Walker->next;
-		*out << Verbose(4) << "Atom " << Walker->Name << "/" << Walker->nr << " with " << NumberOfBondsPerAtom[Walker->nr] << " bonds: ";
-		TotalDegree = 0;
-		for (int j=0;j<NumberOfBondsPerAtom[Walker->nr];j++) {
-			*out << *ListOfBondsPerAtom[Walker->nr][j] << "\t";
-			TotalDegree += ListOfBondsPerAtom[Walker->nr][j]->BondDegree;
-		}
-		*out << " -- TotalDegree: " << TotalDegree << endl;
-	}
-	*out << Verbose(1) << "End of Creating ListOfBondsPerAtom." << endl << endl;
+  bond *Binder = NULL;
+  atom *Walker = NULL;
+  int TotalDegree;
+  *out << Verbose(1) << "Begin of Creating ListOfBondsPerAtom: AtomCount = " << AtomCount << "\tBondCount = " << BondCount << "\tNoNonBonds = " << NoNonBonds << "." << endl;
+
+  // re-allocate memory
+  *out << Verbose(2) << "(Re-)Allocating memory." << endl;
+  if (ListOfBondsPerAtom != NULL) {
+    for(int i=AtomCount;i--;)
+      Free((void **)&ListOfBondsPerAtom[i], "molecule::CreateListOfBondsPerAtom: ListOfBondsPerAtom[i]");
+    Free((void **)&ListOfBondsPerAtom, "molecule::CreateListOfBondsPerAtom: ListOfBondsPerAtom");
+  }
+  if (NumberOfBondsPerAtom != NULL)
+    Free((void **)&NumberOfBondsPerAtom, "molecule::CreateListOfBondsPerAtom: NumberOfBondsPerAtom");
+  ListOfBondsPerAtom = (bond ***) Malloc(sizeof(bond **)*AtomCount, "molecule::CreateListOfBondsPerAtom: ***ListOfBondsPerAtom");
+  NumberOfBondsPerAtom = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CreateListOfBondsPerAtom: *NumberOfBondsPerAtom");
+
+  // reset bond counts per atom
+  for(int i=AtomCount;i--;)
+    NumberOfBondsPerAtom[i] = 0;
+  // count bonds per atom
+  Binder = first;
+  while (Binder->next != last) {
+    Binder = Binder->next;
+    NumberOfBondsPerAtom[Binder->leftatom->nr]++;
+    NumberOfBondsPerAtom[Binder->rightatom->nr]++;
+  }
+  for(int i=AtomCount;i--;) {
+    // allocate list of bonds per atom
+    ListOfBondsPerAtom[i] = (bond **) Malloc(sizeof(bond *)*NumberOfBondsPerAtom[i], "molecule::CreateListOfBondsPerAtom: **ListOfBondsPerAtom[]");
+    // clear the list again, now each NumberOfBondsPerAtom marks current free field
+    NumberOfBondsPerAtom[i] = 0;
+  }
+  // fill the list
+  Binder = first;
+  while (Binder->next != last) {
+    Binder = Binder->next;
+    ListOfBondsPerAtom[Binder->leftatom->nr][NumberOfBondsPerAtom[Binder->leftatom->nr]++] = Binder;
+    ListOfBondsPerAtom[Binder->rightatom->nr][NumberOfBondsPerAtom[Binder->rightatom->nr]++] = Binder;
+  }
+
+  // output list for debugging
+  *out << Verbose(3) << "ListOfBondsPerAtom for each atom:" << endl;
+  Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    *out << Verbose(4) << "Atom " << Walker->Name << "/" << Walker->nr << " with " << NumberOfBondsPerAtom[Walker->nr] << " bonds: ";
+    TotalDegree = 0;
+    for (int j=0;j<NumberOfBondsPerAtom[Walker->nr];j++) {
+      *out << *ListOfBondsPerAtom[Walker->nr][j] << "\t";
+      TotalDegree += ListOfBondsPerAtom[Walker->nr][j]->BondDegree;
+    }
+    *out << " -- TotalDegree: " << TotalDegree << endl;
+  }
+  *out << Verbose(1) << "End of Creating ListOfBondsPerAtom." << endl << endl;
 };
 
@@ -3380,115 +4076,115 @@
 void molecule::BreadthFirstSearchAdd(ofstream *out, molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem)
 {
-	atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::BreadthFirstSearchAdd: **PredecessorList");
-	int *ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::BreadthFirstSearchAdd: *ShortestPathList");
-	enum Shading *ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::BreadthFirstSearchAdd: *ColorList");
-	class StackClass<atom *> *AtomStack = new StackClass<atom *>(AtomCount);
-	atom *Walker = NULL, *OtherAtom = NULL;
-	bond *Binder = NULL;
-
-	// add Root if not done yet
-	AtomStack->ClearStack();
-	if (AddedAtomList[Root->nr] == NULL)	// add Root if not yet present
-		AddedAtomList[Root->nr] = Mol->AddCopyAtom(Root);
-	AtomStack->Push(Root);
-
-	// initialise each vertex as white with no predecessor, empty queue, color Root lightgray
-	for (int i=AtomCount;i--;) {
-		PredecessorList[i] = NULL;
-		ShortestPathList[i] = -1;
-		if (AddedAtomList[i] != NULL) // mark already present atoms (i.e. Root and maybe others) as visited
-			ColorList[i] = lightgray;
-		else
-			ColorList[i] = white;
-	}
-	ShortestPathList[Root->nr] = 0;
-
-	// and go on ... Queue always contains all lightgray vertices
-	while (!AtomStack->IsEmpty()) {
-		// we have to pop the oldest atom from stack. This keeps the atoms on the stack always of the same ShortestPath distance.
-		// e.g. if current atom is 2, push to end of stack are of length 3, but first all of length 2 would be popped. They again
-		// append length of 3 (their neighbours). Thus on stack we have always atoms of a certain length n at bottom of stack and
-		// followed by n+1 till top of stack.
-		Walker = AtomStack->PopFirst(); // pop oldest added
-		*out << Verbose(1) << "Current Walker is: " << Walker->Name << ", and has " << NumberOfBondsPerAtom[Walker->nr] << " bonds." << endl;
-		for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
-			Binder = ListOfBondsPerAtom[Walker->nr][i];
-			if (Binder != NULL) { // don't look at bond equal NULL
-				OtherAtom = Binder->GetOtherAtom(Walker);
-				*out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
-				if (ColorList[OtherAtom->nr] == white) {
-					if (Binder != Bond) // let other atom white if it's via Root bond. In case it's cyclic it has to be reached again (yet Root is from OtherAtom already black, thus no problem)
-						ColorList[OtherAtom->nr] = lightgray;
-					PredecessorList[OtherAtom->nr] = Walker;	// Walker is the predecessor
-					ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
-					*out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
-					if ((((ShortestPathList[OtherAtom->nr] < BondOrder) && (Binder != Bond))) ) { // Check for maximum distance
-						*out << Verbose(3);
-						if (AddedAtomList[OtherAtom->nr] == NULL) { // add if it's not been so far
-							AddedAtomList[OtherAtom->nr] = Mol->AddCopyAtom(OtherAtom);
-							*out << "Added OtherAtom " << OtherAtom->Name;
-							AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
-							AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
-							AddedBondList[Binder->nr]->Type = Binder->Type;
-							*out << " and bond " << *(AddedBondList[Binder->nr]) << ", ";
-						} else {	// this code should actually never come into play (all white atoms are not yet present in BondMolecule, that's why they are white in the first place)
-							*out << "Not adding OtherAtom " << OtherAtom->Name;
-							if (AddedBondList[Binder->nr] == NULL) {
-								AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
-								AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
-								AddedBondList[Binder->nr]->Type = Binder->Type;
-								*out << ", added Bond " << *(AddedBondList[Binder->nr]);
-							} else
-								*out << ", not added Bond ";
-						}
-						*out << ", putting OtherAtom into queue." << endl;
-						AtomStack->Push(OtherAtom);
-					} else { // out of bond order, then replace
-						if ((AddedAtomList[OtherAtom->nr] == NULL) && (Binder->Cyclic))
-							ColorList[OtherAtom->nr] = white; // unmark if it has not been queued/added, to make it available via its other bonds (cyclic)
-						if (Binder == Bond)
-							*out << Verbose(3) << "Not Queueing, is the Root bond";
-						else if (ShortestPathList[OtherAtom->nr] >= BondOrder)
-							*out << Verbose(3) << "Not Queueing, is out of Bond Count of " << BondOrder;
-						if (!Binder->Cyclic)
-							*out << ", is not part of a cyclic bond, saturating bond with Hydrogen." << endl;
-						if (AddedBondList[Binder->nr] == NULL) {
-							if ((AddedAtomList[OtherAtom->nr] != NULL)) { // .. whether we add or saturate
-								AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
-								AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
-								AddedBondList[Binder->nr]->Type = Binder->Type;
-							} else {
+  atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::BreadthFirstSearchAdd: **PredecessorList");
+  int *ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::BreadthFirstSearchAdd: *ShortestPathList");
+  enum Shading *ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::BreadthFirstSearchAdd: *ColorList");
+  class StackClass<atom *> *AtomStack = new StackClass<atom *>(AtomCount);
+  atom *Walker = NULL, *OtherAtom = NULL;
+  bond *Binder = NULL;
+
+  // add Root if not done yet
+  AtomStack->ClearStack();
+  if (AddedAtomList[Root->nr] == NULL)  // add Root if not yet present
+    AddedAtomList[Root->nr] = Mol->AddCopyAtom(Root);
+  AtomStack->Push(Root);
+
+  // initialise each vertex as white with no predecessor, empty queue, color Root lightgray
+  for (int i=AtomCount;i--;) {
+    PredecessorList[i] = NULL;
+    ShortestPathList[i] = -1;
+    if (AddedAtomList[i] != NULL) // mark already present atoms (i.e. Root and maybe others) as visited
+      ColorList[i] = lightgray;
+    else
+      ColorList[i] = white;
+  }
+  ShortestPathList[Root->nr] = 0;
+
+  // and go on ... Queue always contains all lightgray vertices
+  while (!AtomStack->IsEmpty()) {
+    // we have to pop the oldest atom from stack. This keeps the atoms on the stack always of the same ShortestPath distance.
+    // e.g. if current atom is 2, push to end of stack are of length 3, but first all of length 2 would be popped. They again
+    // append length of 3 (their neighbours). Thus on stack we have always atoms of a certain length n at bottom of stack and
+    // followed by n+1 till top of stack.
+    Walker = AtomStack->PopFirst(); // pop oldest added
+    *out << Verbose(1) << "Current Walker is: " << Walker->Name << ", and has " << NumberOfBondsPerAtom[Walker->nr] << " bonds." << endl;
+    for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
+      Binder = ListOfBondsPerAtom[Walker->nr][i];
+      if (Binder != NULL) { // don't look at bond equal NULL
+        OtherAtom = Binder->GetOtherAtom(Walker);
+        *out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
+        if (ColorList[OtherAtom->nr] == white) {
+          if (Binder != Bond) // let other atom white if it's via Root bond. In case it's cyclic it has to be reached again (yet Root is from OtherAtom already black, thus no problem)
+            ColorList[OtherAtom->nr] = lightgray;
+          PredecessorList[OtherAtom->nr] = Walker;  // Walker is the predecessor
+          ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
+          *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
+          if ((((ShortestPathList[OtherAtom->nr] < BondOrder) && (Binder != Bond))) ) { // Check for maximum distance
+            *out << Verbose(3);
+            if (AddedAtomList[OtherAtom->nr] == NULL) { // add if it's not been so far
+              AddedAtomList[OtherAtom->nr] = Mol->AddCopyAtom(OtherAtom);
+              *out << "Added OtherAtom " << OtherAtom->Name;
+              AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
+              AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
+              AddedBondList[Binder->nr]->Type = Binder->Type;
+              *out << " and bond " << *(AddedBondList[Binder->nr]) << ", ";
+            } else {  // this code should actually never come into play (all white atoms are not yet present in BondMolecule, that's why they are white in the first place)
+              *out << "Not adding OtherAtom " << OtherAtom->Name;
+              if (AddedBondList[Binder->nr] == NULL) {
+                AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
+                AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
+                AddedBondList[Binder->nr]->Type = Binder->Type;
+                *out << ", added Bond " << *(AddedBondList[Binder->nr]);
+              } else
+                *out << ", not added Bond ";
+            }
+            *out << ", putting OtherAtom into queue." << endl;
+            AtomStack->Push(OtherAtom);
+          } else { // out of bond order, then replace
+            if ((AddedAtomList[OtherAtom->nr] == NULL) && (Binder->Cyclic))
+              ColorList[OtherAtom->nr] = white; // unmark if it has not been queued/added, to make it available via its other bonds (cyclic)
+            if (Binder == Bond)
+              *out << Verbose(3) << "Not Queueing, is the Root bond";
+            else if (ShortestPathList[OtherAtom->nr] >= BondOrder)
+              *out << Verbose(3) << "Not Queueing, is out of Bond Count of " << BondOrder;
+            if (!Binder->Cyclic)
+              *out << ", is not part of a cyclic bond, saturating bond with Hydrogen." << endl;
+            if (AddedBondList[Binder->nr] == NULL) {
+              if ((AddedAtomList[OtherAtom->nr] != NULL)) { // .. whether we add or saturate
+                AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
+                AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
+                AddedBondList[Binder->nr]->Type = Binder->Type;
+              } else {
 #ifdef ADDHYDROGEN
-								if (!Mol->AddHydrogenReplacementAtom(out, Binder, AddedAtomList[Walker->nr], Walker, OtherAtom, ListOfBondsPerAtom[Walker->nr], NumberOfBondsPerAtom[Walker->nr], IsAngstroem))
-									exit(1);
+                if (!Mol->AddHydrogenReplacementAtom(out, Binder, AddedAtomList[Walker->nr], Walker, OtherAtom, ListOfBondsPerAtom[Walker->nr], NumberOfBondsPerAtom[Walker->nr], IsAngstroem))
+                  exit(1);
 #endif
-							}
-						}
-					}
-				} else {
-					*out << Verbose(3) << "Not Adding, has already been visited." << endl;
-					// This has to be a cyclic bond, check whether it's present ...
-					if (AddedBondList[Binder->nr] == NULL) {
-						if ((Binder != Bond) && (Binder->Cyclic) && (((ShortestPathList[Walker->nr]+1) < BondOrder))) {
-							AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
-							AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
-							AddedBondList[Binder->nr]->Type = Binder->Type;
-						} else { // if it's root bond it has to broken (otherwise we would not create the fragments)
+              }
+            }
+          }
+        } else {
+          *out << Verbose(3) << "Not Adding, has already been visited." << endl;
+          // This has to be a cyclic bond, check whether it's present ...
+          if (AddedBondList[Binder->nr] == NULL) {
+            if ((Binder != Bond) && (Binder->Cyclic) && (((ShortestPathList[Walker->nr]+1) < BondOrder))) {
+              AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
+              AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
+              AddedBondList[Binder->nr]->Type = Binder->Type;
+            } else { // if it's root bond it has to broken (otherwise we would not create the fragments)
 #ifdef ADDHYDROGEN
-							if(!Mol->AddHydrogenReplacementAtom(out, Binder, AddedAtomList[Walker->nr], Walker, OtherAtom, ListOfBondsPerAtom[Walker->nr], NumberOfBondsPerAtom[Walker->nr], IsAngstroem))
-								exit(1);
+              if(!Mol->AddHydrogenReplacementAtom(out, Binder, AddedAtomList[Walker->nr], Walker, OtherAtom, ListOfBondsPerAtom[Walker->nr], NumberOfBondsPerAtom[Walker->nr], IsAngstroem))
+                exit(1);
 #endif
-						}
-					}
-				}
-			}
-		}
-		ColorList[Walker->nr] = black;
-		*out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
-	}
-	Free((void **)&PredecessorList, "molecule::BreadthFirstSearchAdd: **PredecessorList");
-	Free((void **)&ShortestPathList, "molecule::BreadthFirstSearchAdd: **ShortestPathList");
-	Free((void **)&ColorList, "molecule::BreadthFirstSearchAdd: **ColorList");
-	delete(AtomStack);
+            }
+          }
+        }
+      }
+    }
+    ColorList[Walker->nr] = black;
+    *out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
+  }
+  Free((void **)&PredecessorList, "molecule::BreadthFirstSearchAdd: **PredecessorList");
+  Free((void **)&ShortestPathList, "molecule::BreadthFirstSearchAdd: **ShortestPathList");
+  Free((void **)&ColorList, "molecule::BreadthFirstSearchAdd: **ColorList");
+  delete(AtomStack);
 };
 
@@ -3504,48 +4200,48 @@
 bool molecule::BuildInducedSubgraph(ofstream *out, const molecule *Father)
 {
-	atom *Walker = NULL, *OtherAtom = NULL;
-	bool status = true;
-	atom **ParentList = (atom **) Malloc(sizeof(atom *)*Father->AtomCount, "molecule::BuildInducedSubgraph: **ParentList");
-
-	*out << Verbose(2) << "Begin of BuildInducedSubgraph." << endl;
-
-	// reset parent list
-	*out << Verbose(3) << "Resetting ParentList." << endl;
-	for (int i=Father->AtomCount;i--;)
-		ParentList[i] = NULL;
-
-	// fill parent list with sons
-	*out << Verbose(3) << "Filling Parent List." << endl;
-	Walker = start;
-	while (Walker->next != end) {
-		Walker = Walker->next;
-		ParentList[Walker->father->nr] = Walker;
-		// Outputting List for debugging
-		*out << Verbose(4) << "Son["<< Walker->father->nr <<"] of " << Walker->father <<	" is " << ParentList[Walker->father->nr] << "." << endl;
-	}
-
-	// check each entry of parent list and if ok (one-to-and-onto matching) create bonds
-	*out << Verbose(3) << "Creating bonds." << endl;
-	Walker = Father->start;
-	while (Walker->next != Father->end) {
-		Walker = Walker->next;
-		if (ParentList[Walker->nr] != NULL) {
-			if (ParentList[Walker->nr]->father != Walker) {
-				status = false;
-			} else {
-				for (int i=0;i<Father->NumberOfBondsPerAtom[Walker->nr];i++) {
-					OtherAtom = Father->ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
-					if (ParentList[OtherAtom->nr] != NULL) { // if otheratom is also a father of an atom on this molecule, create the bond
-						*out << Verbose(4) << "Endpoints of Bond " << Father->ListOfBondsPerAtom[Walker->nr][i] << " are both present: " << ParentList[Walker->nr]->Name << " and " << ParentList[OtherAtom->nr]->Name << "." << endl;
-						AddBond(ParentList[Walker->nr], ParentList[OtherAtom->nr], Father->ListOfBondsPerAtom[Walker->nr][i]->BondDegree);
-					}
-				}
-			}
-		}
-	}
-
-	Free((void **)&ParentList, "molecule::BuildInducedSubgraph: **ParentList");
-	*out << Verbose(2) << "End of BuildInducedSubgraph." << endl;
-	return status;
+  atom *Walker = NULL, *OtherAtom = NULL;
+  bool status = true;
+  atom **ParentList = (atom **) Malloc(sizeof(atom *)*Father->AtomCount, "molecule::BuildInducedSubgraph: **ParentList");
+
+  *out << Verbose(2) << "Begin of BuildInducedSubgraph." << endl;
+
+  // reset parent list
+  *out << Verbose(3) << "Resetting ParentList." << endl;
+  for (int i=Father->AtomCount;i--;)
+    ParentList[i] = NULL;
+
+  // fill parent list with sons
+  *out << Verbose(3) << "Filling Parent List." << endl;
+  Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    ParentList[Walker->father->nr] = Walker;
+    // Outputting List for debugging
+    *out << Verbose(4) << "Son["<< Walker->father->nr <<"] of " << Walker->father <<  " is " << ParentList[Walker->father->nr] << "." << endl;
+  }
+
+  // check each entry of parent list and if ok (one-to-and-onto matching) create bonds
+  *out << Verbose(3) << "Creating bonds." << endl;
+  Walker = Father->start;
+  while (Walker->next != Father->end) {
+    Walker = Walker->next;
+    if (ParentList[Walker->nr] != NULL) {
+      if (ParentList[Walker->nr]->father != Walker) {
+        status = false;
+      } else {
+        for (int i=0;i<Father->NumberOfBondsPerAtom[Walker->nr];i++) {
+          OtherAtom = Father->ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
+          if (ParentList[OtherAtom->nr] != NULL) { // if otheratom is also a father of an atom on this molecule, create the bond
+            *out << Verbose(4) << "Endpoints of Bond " << Father->ListOfBondsPerAtom[Walker->nr][i] << " are both present: " << ParentList[Walker->nr]->Name << " and " << ParentList[OtherAtom->nr]->Name << "." << endl;
+            AddBond(ParentList[Walker->nr], ParentList[OtherAtom->nr], Father->ListOfBondsPerAtom[Walker->nr][i]->BondDegree);
+          }
+        }
+      }
+    }
+  }
+
+  Free((void **)&ParentList, "molecule::BuildInducedSubgraph: **ParentList");
+  *out << Verbose(2) << "End of BuildInducedSubgraph." << endl;
+  return status;
 };
 
@@ -3559,20 +4255,20 @@
 int molecule::LookForRemovalCandidate(ofstream *&out, KeySet *&Leaf, int *&ShortestPathList)
 {
-	atom *Runner = NULL;
-	int SP, Removal;
-
-	*out << Verbose(2) << "Looking for removal candidate." << endl;
-	SP = -1; //0;	// not -1, so that Root is never removed
-	Removal = -1;
-	for (KeySet::iterator runner = Leaf->begin(); runner != Leaf->end(); runner++) {
-		Runner = FindAtom((*runner));
-		if (Runner->type->Z != 1) { // skip all those added hydrogens when re-filling snake stack
-			if (ShortestPathList[(*runner)] > SP) {	// remove the oldest one with longest shortest path
-				SP = ShortestPathList[(*runner)];
-				Removal = (*runner);
-			}
-		}
-	}
-	return Removal;
+  atom *Runner = NULL;
+  int SP, Removal;
+
+  *out << Verbose(2) << "Looking for removal candidate." << endl;
+  SP = -1; //0;  // not -1, so that Root is never removed
+  Removal = -1;
+  for (KeySet::iterator runner = Leaf->begin(); runner != Leaf->end(); runner++) {
+    Runner = FindAtom((*runner));
+    if (Runner->type->Z != 1) { // skip all those added hydrogens when re-filling snake stack
+      if (ShortestPathList[(*runner)] > SP) {  // remove the oldest one with longest shortest path
+        SP = ShortestPathList[(*runner)];
+        Removal = (*runner);
+      }
+    }
+  }
+  return Removal;
 };
 
